void bullet_touch(entity_t *self, entity_t *other) {
	if (self == NULL || other == NULL) return;
	if ((other != self->owner) && (other->class != CLASS_BULLET)) {
		damage(other, self, self->owner, self->attack_damage);
		if (!(self->flags & FLAG_BULLETPIERCE)) kill(self);		// Remove the bullet
	}
};


void render_bullet(struct entity_t *self) {
	if (self == NULL) return;
	int x = (self->x >> 8) - screen_x;
	int y = (self->y >> 8) - screen_y;
	
	Sprite8(x, y, 8, sprites_bullet[0], sprtbufl, A_OR);
	Sprite8(x, y, 8, sprites_bullet[1], sprtbufd, A_OR);
};


entity_t *spawn_bullet(entity_t *self, signed long xo, signed long yo, signed short dmg) {
	if (self == NULL) return;
	
	entity_t	*bullet = spawn();
	if (bullet == NULL) return NULL;
	bullet->class = CLASS_BULLET;
	bullet->width = 8; bullet->height = 8;
	bullet->x = self->x + xo;
	bullet->y = self->y + yo;
	bullet->dx = ((self->flags & FLAG_FACERIGHT) ? 1200 : -1200);
	bullet->dy = 0;
	bullet->render = (func_t *)render_bullet;
	bullet->flags = FLAG_NOGRAVITY | (self->flags & FLAG_FACERIGHT) | FLAG_NOFRICTION;
	bullet->owner = self;
	bullet->touch = (touch_t *)bullet_touch;
	bullet->death = (func_t *)sub_remove;
	bullet->attack_damage = dmg;
	bullet->next_think = time + 32;
	bullet->think = (func_t *)sub_remove;
	return bullet;
};
