void render_grunt(struct entity_t *self) {
	draw_player(self);
};


void grunt_think(struct entity_t *self) {
	if (self == NULL) return;
	if ((rand() % 30 == time % 30) && (self->attack_time <= time)) {
		self->attack_time = time + 8;
		spawn_bullet(self, ((self->flags & FLAG_FACERIGHT) ? (8 << 8) : -(8 << 8)), 8 << 8, 32 + (rand() % 8) - 8);
	}
	self->dx = (self->flags & FLAG_FACERIGHT) ? 640 : -640;
	if ((rand() % 20 == 2) && (player->y + (16 << 8) < self->y) && (self->flags & FLAG_ONGROUND)) {
		self->dy -= 1400;
		self->flags &= ~FLAG_ONGROUND;
	};
	self->next_think = time + 1;
};

void grunt_touch(struct entity_t *self, struct entity_t *other) {
	if (other->class != CLASS_PLAYER) return;
	if (self->attack_time <= time) {
		self->attack_time = time + 30;
		damage(other, self, self, 24 + (rand() % 8) - 8);
	};
};

entity_t *spawn_grunt() {
	entity_t *curr = spawn();
	if (curr != NULL) {
		curr->flags = FLAG_NOFRICTION;
		curr->width = 8; curr->height = 16;
		if (rand() % 50 <= 24) {
			curr->x = ((screen_x + screen_w - 8) << 8);
			curr->dx = -600;
			curr->flags &= ~FLAG_FACERIGHT;
		} else {
			curr->x = ((screen_x + 8) << 8);
			curr->dx = 600;
			curr->flags |= FLAG_FACERIGHT;
		};
		curr->y = player->y - 768;
		curr->class = CLASS_GRUNT;
		curr->dy = 0;
		curr->render = (func_t *)render_grunt;
		curr->think = (func_t *)grunt_think;
		curr->death = (func_t *)sub_remove;
		curr->touch = (touch_t *)grunt_touch;
		curr->next_think = time + 1;
		// Grunt's health is 32, which is the same amount of damage a player's bullet does.
		curr->health = curr->max_health = 32;
	};
	return curr;
};

