#include <stdlib.h>
#include <stdio.h>
#include "selector.h"

int main(void) {
	FILE	*fout = fopen("selectorspr.h", "w");
	int i, l, r;
	unsigned short light, dark;

	unsigned long size = (width*height) >> 3;

	fprintf(fout, "static unsigned short selector_l[%d] = {", size);
	fprintf(fout, "\n\t\t");
	for (i=0;i<size;i++) {
		l = (i << 4);
		light = 0;
		for (r = 0; r <= 15; r++) {
			light |= (((3 - header_data[l + 15 - r])) & 1) << r;
		}
		fprintf(fout, "0x%04X", light);
		if (i != size - 1) fprintf(fout, ", ");
		if ((i % 8) == 7) fprintf(fout, "\n\t\t");
	};
	fprintf(fout, "};\n\n");

	fprintf(fout, "static unsigned short selector_d[%d] = {", size);
	fprintf(fout, "\n\t\t");
	for (i=0;i<size;i++) {
		l = (i << 4);
		dark = 0;
		for (r = 0; r <= 15; r++) {
			dark |= (((3 - header_data[l + 15 - r]) >> 1) & 1) << r;
		}
		fprintf(fout, "0x%04X", dark);
		if (i != size - 1) fprintf(fout, ", ");
		if ((i % 8) == 7) fprintf(fout, "\n\t\t");
	};
	fprintf(fout, "};\n\n");

	fclose(fout);
};
